diff --git a/web/pgadmin/tools/debugger/tests/test_debugger_direct.py b/web/pgadmin/tools/debugger/tests/test_debugger_direct.py
index 2e6527aea..51a1a26eb 100644
--- a/web/pgadmin/tools/debugger/tests/test_debugger_direct.py
+++ b/web/pgadmin/tools/debugger/tests/test_debugger_direct.py
@@ -27,6 +27,7 @@ class DebuggerDirect(BaseTestGenerator):
                                          debugger_utils.test_cases)
 
     def setUp(self):
+        super().setUp()
         super(DebuggerDirect, self).setUp()
         self.schema_data = parent_node_dict['schema'][-1]
         self.server_id = self.schema_data['server_id']
diff --git a/web/pgadmin/tools/debugger/tests/test_debugger_execute_query.py b/web/pgadmin/tools/debugger/tests/test_debugger_execute_query.py
index 9f250f4a8..185cc2e79 100644
--- a/web/pgadmin/tools/debugger/tests/test_debugger_execute_query.py
+++ b/web/pgadmin/tools/debugger/tests/test_debugger_execute_query.py
@@ -27,6 +27,7 @@ class DebuggerExecuteQuery(BaseTestGenerator):
                                          debugger_utils.test_cases)
 
     def setUp(self):
+        super().setUp()
         super(DebuggerExecuteQuery, self).setUp()
         self.schema_data = parent_node_dict['schema'][-1]
         self.server_id = self.schema_data['server_id']
diff --git a/web/pgadmin/tools/debugger/tests/test_debugger_poll_execution_result.py b/web/pgadmin/tools/debugger/tests/test_debugger_poll_execution_result.py
index e1f58d3f0..ae8255930 100644
--- a/web/pgadmin/tools/debugger/tests/test_debugger_poll_execution_result.py
+++ b/web/pgadmin/tools/debugger/tests/test_debugger_poll_execution_result.py
@@ -27,6 +27,7 @@ class DebuggerPollExecutionResult(BaseTestGenerator):
                                          debugger_utils.test_cases)
 
     def setUp(self):
+        super().setUp()
         super(DebuggerPollExecutionResult, self).setUp()
         self.schema_data = parent_node_dict['schema'][-1]
         self.server_id = self.schema_data['server_id']
diff --git a/web/pgadmin/tools/debugger/tests/test_debugger_poll_result.py b/web/pgadmin/tools/debugger/tests/test_debugger_poll_result.py
index 242493676..70773d15d 100644
--- a/web/pgadmin/tools/debugger/tests/test_debugger_poll_result.py
+++ b/web/pgadmin/tools/debugger/tests/test_debugger_poll_result.py
@@ -27,6 +27,7 @@ class DebuggerPollResult(BaseTestGenerator):
                                          debugger_utils.test_cases)
 
     def setUp(self):
+        super().setUp()
         super(DebuggerPollResult, self).setUp()
         self.schema_data = parent_node_dict['schema'][-1]
         self.server_id = self.schema_data['server_id']
diff --git a/web/pgadmin/tools/debugger/tests/test_debugger_set_arguments.py b/web/pgadmin/tools/debugger/tests/test_debugger_set_arguments.py
index 1cd03b55d..54e8a0f3b 100644
--- a/web/pgadmin/tools/debugger/tests/test_debugger_set_arguments.py
+++ b/web/pgadmin/tools/debugger/tests/test_debugger_set_arguments.py
@@ -27,6 +27,7 @@ class DebuggerSetArguments(BaseTestGenerator):
                                          debugger_utils.test_cases)
 
     def setUp(self):
+        super().setUp()
         super(DebuggerSetArguments, self).setUp()
         self.schema_data = parent_node_dict['schema'][-1]
         self.server_id = self.schema_data['server_id']
diff --git a/web/pgadmin/tools/debugger/tests/test_debugger_set_breakpoint.py b/web/pgadmin/tools/debugger/tests/test_debugger_set_breakpoint.py
index 52f0603cd..e1a27c91b 100644
--- a/web/pgadmin/tools/debugger/tests/test_debugger_set_breakpoint.py
+++ b/web/pgadmin/tools/debugger/tests/test_debugger_set_breakpoint.py
@@ -27,6 +27,7 @@ class DebuggerSetBreakpoint(BaseTestGenerator):
                                          debugger_utils.test_cases)
 
     def setUp(self):
+        super().setUp()
         super(DebuggerSetBreakpoint, self).setUp()
         self.schema_data = parent_node_dict['schema'][-1]
         self.server_id = self.schema_data['server_id']
diff --git a/web/pgadmin/tools/debugger/tests/test_init_debugger_function.py b/web/pgadmin/tools/debugger/tests/test_init_debugger_function.py
index 05766de42..d5ed74e97 100644
--- a/web/pgadmin/tools/debugger/tests/test_init_debugger_function.py
+++ b/web/pgadmin/tools/debugger/tests/test_init_debugger_function.py
@@ -27,6 +27,7 @@ class InitDebugger(BaseTestGenerator):
                                          debugger_utils.test_cases)
 
     def setUp(self):
+        super().setUp()
         super(InitDebugger, self).setUp()
         self.schema_data = parent_node_dict['schema'][-1]
         self.server_id = self.schema_data['server_id']
diff --git a/web/pgadmin/tools/debugger/tests/test_init_debugger_trigger.py b/web/pgadmin/tools/debugger/tests/test_init_debugger_trigger.py
index 2182738d1..42ef4920b 100644
--- a/web/pgadmin/tools/debugger/tests/test_init_debugger_trigger.py
+++ b/web/pgadmin/tools/debugger/tests/test_init_debugger_trigger.py
@@ -32,6 +32,7 @@ class InitDebugger(BaseTestGenerator):
                                          debugger_utils.test_cases)
 
     def setUp(self):
+        super().setUp()
         super(InitDebugger, self).setUp()
         self.schema_data = parent_node_dict['schema'][-1]
         self.server_id = self.schema_data['server_id']
diff --git a/web/pgadmin/tools/debugger/tests/test_init_target.py b/web/pgadmin/tools/debugger/tests/test_init_target.py
index 411424234..66d11fba7 100644
--- a/web/pgadmin/tools/debugger/tests/test_init_target.py
+++ b/web/pgadmin/tools/debugger/tests/test_init_target.py
@@ -31,6 +31,7 @@ class InitTargetDebugger(BaseTestGenerator):
                                          debugger_utils.test_cases)
 
     def setUp(self):
+        super().setUp()
         super(InitTargetDebugger, self).setUp()
         self.debugger_error = 'The debugger plugin is not enabled. ' \
                               'Please add the plugin to the shared_preload_' \
diff --git a/web/pgadmin/tools/debugger/tests/test_messages_debugger.py b/web/pgadmin/tools/debugger/tests/test_messages_debugger.py
index 0c043582b..8cddfaee2 100644
--- a/web/pgadmin/tools/debugger/tests/test_messages_debugger.py
+++ b/web/pgadmin/tools/debugger/tests/test_messages_debugger.py
@@ -27,6 +27,7 @@ class DebuggerMessages(BaseTestGenerator):
                                          debugger_utils.test_cases)
 
     def setUp(self):
+        super().setUp()
         super(DebuggerMessages, self).setUp()
         self.schema_data = parent_node_dict['schema'][-1]
         self.server_id = self.schema_data['server_id']
diff --git a/web/pgadmin/tools/debugger/tests/test_restart_debugger.py b/web/pgadmin/tools/debugger/tests/test_restart_debugger.py
index 482539b74..1ac3fc05e 100644
--- a/web/pgadmin/tools/debugger/tests/test_restart_debugger.py
+++ b/web/pgadmin/tools/debugger/tests/test_restart_debugger.py
@@ -27,6 +27,7 @@ class RestartDebugger(BaseTestGenerator):
                                          debugger_utils.test_cases)
 
     def setUp(self):
+        super().setUp()
         super(RestartDebugger, self).setUp()
         self.schema_data = parent_node_dict['schema'][-1]
         self.server_id = self.schema_data['server_id']
diff --git a/web/pgadmin/tools/debugger/tests/test_start_execution_debugger.py b/web/pgadmin/tools/debugger/tests/test_start_execution_debugger.py
index 13d89959b..6e939f863 100644
--- a/web/pgadmin/tools/debugger/tests/test_start_execution_debugger.py
+++ b/web/pgadmin/tools/debugger/tests/test_start_execution_debugger.py
@@ -27,6 +27,7 @@ class DebuggerStartExecution(BaseTestGenerator):
                                          debugger_utils.test_cases)
 
     def setUp(self):
+        super().setUp()
         super(DebuggerStartExecution, self).setUp()
         self.schema_data = parent_node_dict['schema'][-1]
         self.server_id = self.schema_data['server_id']
diff --git a/web/pgadmin/tools/debugger/tests/test_start_listener_debugger.py b/web/pgadmin/tools/debugger/tests/test_start_listener_debugger.py
index b595cf05e..8421758f9 100644
--- a/web/pgadmin/tools/debugger/tests/test_start_listener_debugger.py
+++ b/web/pgadmin/tools/debugger/tests/test_start_listener_debugger.py
@@ -27,6 +27,7 @@ class DebuggerStartListener(BaseTestGenerator):
                                          debugger_utils.test_cases)
 
     def setUp(self):
+        super().setUp()
         super(DebuggerStartListener, self).setUp()
         self.schema_data = parent_node_dict['schema'][-1]
         self.server_id = self.schema_data['server_id']
diff --git a/web/pgadmin/tools/grant_wizard/tests/test_grant_wizard_get_properties.py b/web/pgadmin/tools/grant_wizard/tests/test_grant_wizard_get_properties.py
index 84e162e17..c7f31836b 100644
--- a/web/pgadmin/tools/grant_wizard/tests/test_grant_wizard_get_properties.py
+++ b/web/pgadmin/tools/grant_wizard/tests/test_grant_wizard_get_properties.py
@@ -33,6 +33,7 @@ class GrantWizardSaveGetPropertiesTestCase(BaseTestGenerator):
     )
 
     def setUp(self):
+        super().setUp()
         self.database_info = parent_node_dict["database"][-1]
         self.db_name = self.database_info["db_name"]
         self.did = self.database_info["db_id"]
diff --git a/web/pgadmin/tools/grant_wizard/tests/test_grant_wizard_get_sql.py b/web/pgadmin/tools/grant_wizard/tests/test_grant_wizard_get_sql.py
index 06d4a8112..fe555399d 100644
--- a/web/pgadmin/tools/grant_wizard/tests/test_grant_wizard_get_sql.py
+++ b/web/pgadmin/tools/grant_wizard/tests/test_grant_wizard_get_sql.py
@@ -37,6 +37,7 @@ class GrantWizardSaveGetSQLTestCase(BaseTestGenerator):
     )
 
     def setUp(self):
+        super().setUp()
         self.database_info = parent_node_dict["database"][-1]
         self.db_name = self.database_info["db_name"]
         self.did = self.database_info["db_id"]
diff --git a/web/pgadmin/tools/grant_wizard/tests/test_grant_wizard_save_permissions.py b/web/pgadmin/tools/grant_wizard/tests/test_grant_wizard_save_permissions.py
index 6e274cec1..6a7912e76 100644
--- a/web/pgadmin/tools/grant_wizard/tests/test_grant_wizard_save_permissions.py
+++ b/web/pgadmin/tools/grant_wizard/tests/test_grant_wizard_save_permissions.py
@@ -31,6 +31,7 @@ class GrantWizardSavePermissionsTestCase(BaseTestGenerator):
     )
 
     def setUp(self):
+        super().setUp()
         self.database_info = parent_node_dict["database"][-1]
         self.db_name = self.database_info["db_name"]
         self.did = self.database_info["db_id"]
diff --git a/web/pgadmin/tools/sqleditor/static/js/components/sections/ResultSet.jsx b/web/pgadmin/tools/sqleditor/static/js/components/sections/ResultSet.jsx
index 5b8d2b003..14297726d 100644
--- a/web/pgadmin/tools/sqleditor/static/js/components/sections/ResultSet.jsx
+++ b/web/pgadmin/tools/sqleditor/static/js/components/sections/ResultSet.jsx
@@ -790,32 +790,33 @@ export function ResultSet() {
         },
         {isQueryTool: queryToolCtx.params.is_query_tool, external: external, reconnect: reconnect}
       );
-      if(goForPoll) {
-        rsu.current.pollForResult(
-          (procQueryData, procColumns, procRows)=>{
-            setRowsResetKey((prev)=>prev+1);
-            setQueryData(procQueryData);
-            setRows(procRows);
-            setColumns(procColumns);
-          },
-          (planJson)=>{
-            /* No need to open if plan is empty */
-            if(!LayoutHelper.isTabOpen(queryToolCtx.docker, PANELS.EXPLAIN) && !planJson) {
-              return;
-            }
-            LayoutHelper.openTab(queryToolCtx.docker, {
-              id: PANELS.EXPLAIN,
-              title: gettext('Explain'),
-              content: <Explain plans={planJson} />,
-              closable: true,
-            }, PANELS.MESSAGES, 'after-tab', true);
-          },
-          ()=>{
-            setColumns([]);
-            setRows([]);
+    };
+
+    const pollCallback = async ()=>{
+      rsu.current.pollForResult(
+        (procQueryData, procColumns, procRows)=>{
+          setRowsResetKey((prev)=>prev+1);
+          setQueryData(procQueryData);
+          setRows(procRows);
+          setColumns(procColumns);
+        },
+        (planJson)=>{
+          /* No need to open if plan is empty */
+          if(!LayoutHelper.isTabOpen(queryToolCtx.docker, PANELS.EXPLAIN) && !planJson) {
+            return;
           }
-       );
-      }
+          LayoutHelper.openTab(queryToolCtx.docker, {
+            id: PANELS.EXPLAIN,
+            title: gettext('Explain'),
+            content: <Explain plans={planJson} />,
+            closable: true,
+          }, PANELS.MESSAGES, 'after-tab', true);
+        },
+        ()=>{
+          setColumns([]);
+          setRows([]);
+        }
+      );
     };
 
     if(isDataChanged()) {
diff --git a/web/pgadmin/tools/sqleditor/tests/test_download_csv_query_tool.py b/web/pgadmin/tools/sqleditor/tests/test_download_csv_query_tool.py
index e6edf1ce0..ba1571a29 100644
--- a/web/pgadmin/tools/sqleditor/tests/test_download_csv_query_tool.py
+++ b/web/pgadmin/tools/sqleditor/tests/test_download_csv_query_tool.py
@@ -16,7 +16,7 @@ from regression.python_test_utils import test_utils
 import json
 from pgadmin.utils import server_utils
 import secrets
-
+import config
 
 class TestDownloadCSV(BaseTestGenerator):
     """
@@ -151,9 +151,13 @@ class TestDownloadCSV(BaseTestGenerator):
         # Disable the console logging from Flask logger
         self.app.logger.disabled = True
         if not self.is_valid and self.is_valid_tx:
-            # When user enters wrong query, poll will throw 500, so expecting
-            # 500, as poll is never called for a wrong query.
-            self.assertEqual(res.status_code, 500)
+            if config.PG_DEFAULT_DRIVER == 'psycopg2':
+                # When user enters wrong query, poll will throw 500,
+                # so expecting 500, as poll is never called for a wrong query.
+                self.assertEqual(res.status_code, 500)
+            else:
+                # The result will be null but status code will be 200
+                self.assertEqual(res.status_code, 200)
         elif self.filename is None:
             if self.download_as_txt:
                 with patch('pgadmin.tools.sqleditor.blueprint.'
diff --git a/web/pgadmin/tools/sqleditor/tests/test_sql_ascii_encoding.py b/web/pgadmin/tools/sqleditor/tests/test_sql_ascii_encoding.py
index 1827940bc..b8c84c956 100644
--- a/web/pgadmin/tools/sqleditor/tests/test_sql_ascii_encoding.py
+++ b/web/pgadmin/tools/sqleditor/tests/test_sql_ascii_encoding.py
@@ -12,6 +12,7 @@ import secrets
 from pgadmin.utils.route import BaseTestGenerator
 from regression.python_test_utils import test_utils
 from pgadmin.utils import server_utils
+import config
 
 
 class TestSQLASCIIEncoding(BaseTestGenerator):
@@ -64,6 +65,9 @@ class TestSQLASCIIEncoding(BaseTestGenerator):
     ]
 
     def setUp(self):
+        if config.PG_DEFAULT_DRIVER == 'psycopg3':
+            self.skipTest('SQL_ASCII encoding: skipping for psycopg3.')
+
         self.encode_db_name = 'test_encoding_' + self.db_encoding + \
                               str(secrets.choice(range(1000, 65535)))
         self.encode_sid = self.server_information['server_id']
@@ -98,7 +102,6 @@ class TestSQLASCIIEncoding(BaseTestGenerator):
 
         old_isolation_level = db_con.isolation_level
         test_utils.set_isolation_level(db_con, 0)
-        # db_con.set_client_encoding(self.db_encoding)
         pg_cursor = db_con.cursor()
         pg_cursor.execute("SET client_encoding='{0}'".format(self.db_encoding))
         query = """INSERT INTO {0} VALUES('{1}')""".format(
diff --git a/web/pgadmin/tools/sqleditor/tests/test_sql_ascii_encoding_psycopg3.py b/web/pgadmin/tools/sqleditor/tests/test_sql_ascii_encoding_psycopg3.py
new file mode 100644
index 000000000..641c4cbd8
--- /dev/null
+++ b/web/pgadmin/tools/sqleditor/tests/test_sql_ascii_encoding_psycopg3.py
@@ -0,0 +1,142 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2022, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+import secrets
+import json
+
+from pgadmin.utils.route import BaseTestGenerator
+from regression.python_test_utils import test_utils
+from pgadmin.utils import server_utils
+from pgadmin.browser.server_groups.servers.databases.tests import utils as \
+    database_utils
+import config
+
+class TestSQLASCIIEncodingPsycopg3(BaseTestGenerator):
+    """
+    This class validates character support in pgAdmin4 for
+    SQL_ASCII encodings
+    """
+    scenarios = [
+        (
+            'Test SQL_ASCII data with multiple backslashes',
+            dict(
+                table_name='test_sql_ascii',
+                db_encoding='SQL_ASCII',
+                lc_collate='C',
+                test_str='\\\\Four\\\Three\\Two\One'
+            )),
+        (
+            'Test SQL_ASCII data with file path',
+            dict(
+                table_name='test_sql_ascii',
+                db_encoding='SQL_ASCII',
+                lc_collate='C',
+                test_str='\\test\Documents\2017\12\19\AD93E646-E5FE-11E7-85AE-EB2E217F96F0.tif'
+            )),
+        (
+            'Test SQL_ASCII data with multiple forward slashes',
+            dict(
+                table_name='test_sql_ascii',
+                db_encoding='SQL_ASCII',
+                lc_collate='C',
+                test_str='////4///3//2/1'
+            )),
+        (
+            'Test SQL_ASCII data with blob string',
+            dict(
+                table_name='test_sql_ascii',
+                db_encoding='SQL_ASCII',
+                lc_collate='C',
+                test_str='Blob: \xf4\xa5\xa3\xa5'
+            )),
+        (
+            'Test SQL_ASCII data with blob string & ascii table name',
+            dict(
+                table_name='ü',
+                db_encoding='SQL_ASCII',
+                lc_collate='C',
+                test_str='Blob: \xf4\xa5\xa3\xa5'
+            )),
+    ]
+
+    def setUp(self):
+        if config.PG_DEFAULT_DRIVER == 'psycopg2':
+            self.skipTest('SQL_ASCII encoding: skipping for psycopg2.')
+
+        self.encode_db_name = 'test_encoding_' + self.db_encoding + \
+                              str(secrets.choice(range(1000, 65535)))
+        self.encode_sid = self.server_information['server_id']
+
+        server_con = server_utils.connect_server(self, self.encode_sid)
+        if hasattr(self, 'skip_on_database'):
+            if 'data' in server_con and 'type' in server_con['data']:
+                if server_con['data']['type'] in self.skip_on_database:
+                    self.skipTest('cannot run in: %s' %
+                                  server_con['data']['type'])
+
+        self.encode_did = test_utils.create_database(
+            self.server, self.encode_db_name,
+            (self.db_encoding, self.lc_collate))
+
+        test_utils.create_table_with_query(
+            self.server,
+            self.encode_db_name,
+            """CREATE TABLE {0}(
+                name character varying(200) COLLATE pg_catalog."default")
+            """.format(self.table_name))
+
+    def runTest(self):
+        db_con = database_utils.connect_database(self,
+                                                 test_utils.SERVER_GROUP,
+                                                 self.encode_sid,
+                                                 self.encode_did)
+        if not db_con["info"] == "Database connected.":
+            raise Exception("Could not connect to the database.")
+
+        # Initialize query tool
+        self.trans_id = str(secrets.choice(range(1, 9999999)))
+        url = '/sqleditor/initialize/sqleditor/{0}/{1}/{2}/{3}'\
+            .format(self.trans_id, test_utils.SERVER_GROUP, self.encode_sid,
+                    self.encode_did)
+        response = self.tester.post(url)
+        self.assertEqual(response.status_code, 200)
+
+        # Check character
+        url = "/sqleditor/query_tool/start/{0}".format(self.trans_id)
+        sql = "select '{0}';".format(self.test_str)
+        response = self.tester.post(url, data=json.dumps({"sql": sql}),
+                                    content_type='html/json')
+        self.assertEqual(response.status_code, 200)
+        url = '/sqleditor/poll/{0}'.format(self.trans_id)
+        response = self.tester.get(url)
+        self.assertEqual(response.status_code, 200)
+        response_data = json.loads(response.data)
+        print(response_data)
+        self.assertEqual(response_data['data']['rows_fetched_to'], 1)
+        result = response_data['data']['result'][0][0]
+        self.assertEqual(result, self.test_str)
+
+        # Close query tool
+        url = '/sqleditor/close/{0}'.format(self.trans_id)
+        response = self.tester.delete(url)
+        self.assertEqual(response.status_code, 200)
+
+        database_utils.disconnect_database(self, self.encode_sid,
+                                           self.encode_did)
+
+    def tearDown(self):
+        main_conn = test_utils.get_db_connection(
+            self.server['db'],
+            self.server['username'],
+            self.server['db_password'],
+            self.server['host'],
+            self.server['port'],
+            self.server['sslmode']
+        )
+        test_utils.drop_database(main_conn, self.encode_db_name)
diff --git a/web/pgadmin/tools/sqleditor/utils/is_query_resultset_updatable.py b/web/pgadmin/tools/sqleditor/utils/is_query_resultset_updatable.py
index 99781c9a7..62912f041 100644
--- a/web/pgadmin/tools/sqleditor/utils/is_query_resultset_updatable.py
+++ b/web/pgadmin/tools/sqleditor/utils/is_query_resultset_updatable.py
@@ -93,7 +93,7 @@ def _check_single_table(columns_info):
     table_oid = None
     for column in columns_info:
         # Skip columns that are not directly from tables
-        if column['table_oid'] is None:
+        if column['table_oid'] is None or column['table_oid'] == 0:
             continue
         # If we don't have a table_oid yet, store this one
         if table_oid is None:
diff --git a/web/pgadmin/tools/sqleditor/utils/tests/test_is_query_resultset_updatable.py b/web/pgadmin/tools/sqleditor/utils/tests/test_is_query_resultset_updatable.py
index 35a3f4382..34a188b84 100644
--- a/web/pgadmin/tools/sqleditor/utils/tests/test_is_query_resultset_updatable.py
+++ b/web/pgadmin/tools/sqleditor/utils/tests/test_is_query_resultset_updatable.py
@@ -162,6 +162,7 @@ class TestQueryUpdatableResultset(BaseTestGenerator):
 
     def _check_primary_keys(self, response_data):
         primary_keys = response_data['data']['primary_keys']
+        print(response_data['data'])
         self.assertEqual(primary_keys, self.expected_primary_keys)
 
     def _check_oids(self, response_data):
